(function (_global) {

  "use strict";

  var _meta     = {}, // to hold global meta
      _opts     = {}, // config object passed to constructor
      _storage  = null, // localStorage or chrome.storage.* in case of extension/app
      _adoptor  = null, // storage adoptor
      _SEPERATOR = '/',
      _events   = { // events and callback store
        created:  [],
        inserted: [],
        updated:  [],
        removed:  [],
        dropped:  [],
        error:    []
      };

  /* polyfills & custom utility methods */

  // for < IE9 Array.isArray support: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/isArray#Polyfill
  if (!Array.isArray) {
    Array.isArray = function(arg) {
      return Object.prototype.toString.call(arg) === '[object Array]';
    };
  }

  // for < IE9 Array.forEach support: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/forEach#Polyfill
  if (!Array.prototype.forEach) {
    Array.prototype.forEach = function(callback, thisArg) {
      var T, k;
      if (this === null) {
        throw new TypeError('this is null or not defined');
      }
      var O = Object(this);
      var len = O.length >>> 0;
      if (typeof callback !== 'function') {
        throw new TypeError(callback + ' is not a function');
      }
      if (arguments.length > 1) {
        T = thisArg;
      }
      k = 0;
      while (k < len) {
        var kValue;
        if (k in O) {
          kValue = O[k];
          callback.call(T, kValue, k, O);
        }
        k++;
      }
    };
  }

  // check if one array is subset of another: http://stackoverflow.com/a/8632144/1227747
  Array.prototype.containsArray = function ( array ) {

      var index = null,
          last  = null;

      if( arguments[1] ) {
          index = arguments[1];
          last  = arguments[2];
      } else {
          index = 0;
          last  = 0;
          this.sort();
          array.sort();
      }

      return index === array.length ||
             ( last = this.indexOf( array[index], last ) ) > -1 &&
             this.containsArray( array, ++index, ++last );
  };

  // Remove duplicate entries from array: http://stackoverflow.com/a/1961068/1227747
  Array.prototype.unique = function(){
   var u = {}, a = [];
   for(var i = 0, l = this.length; i < l; ++i){
      if(u.hasOwnProperty(this[i])) {
         continue;
      }
      a.push(this[i]);
      u[this[i]] = 1;
   }
   return a;
 };

  /* End polyfills & custom utility methods */

  function init(opts) {
  	console.log(opts);
  }

  var _chota = {
  	init: init
  };

	if(typeof module === 'object' && typeof module.exports === 'object') { // NodeJS support
	  _SEPERATOR = '-';
	  _adoptor 	 = require('node-persist');
	  _adoptor.initSync({
	    dir:       process.env.PWD + '/ChotaData',
	    parse:     function(d) { return d; },
	    stringify: function(d) { return d; }
	  });
	  return module.exports = _chota;
	} else if (typeof define === 'function' && define.amd) { // AMD (RequireJS) support
	  return define('ChotaDB', [], function() {
			return _chota;
	  });
	} else {
		return _global.ChotaDB = _chota;
	}

})(this);
